from django.contrib import admin

from ..models.description import DescriptionTranslation, Description
from ..models import Description


class TranslationDescriptionInline(admin.TabularInline):
    model = DescriptionTranslation
    fields = ('language_code', 'description_translation')
    extra = 0


class DescriptionAdmin(admin.ModelAdmin):
    list_display = ('name','version', 'valid_from')
    fields = ('name','description', 'version', 'valid_from', 'valid_to')

    inlines = [
        TranslationDescriptionInline,
    ]


#admin.site.register(Description, DescriptionAdmin)
#admin.autodiscover()
