from django.db import models

from ..models.exercise_type import ExerciseType

class Exercises(models.Model):
    exercise_id = models.BigAutoField(primary_key=True)
    
    customer_id = models.PositiveIntegerField()
   # exercise_type_id = models.IntegerField()
    exercise_type = models.ForeignKey(ExerciseType, on_delete=models.CASCADE)
    date_add = models.DateField()
    quantity = models.DecimalField(decimal_places=0, max_digits=6)
    unit = models.CharField(max_length=20)
    unit_quantity = models.DecimalField(decimal_places=0, max_digits=6,blank=True, null=True)


    def has_add_permission(self, request):
        return False

    def has_delete_permission(self, request, obj=None):
        return False

    class Meta:
        db_table = 'exercises'
        app_label = 'controlling'
